$fn = 36;
N = 12;
w = 11.5;

nut_min_dia = 5.6; // adafruit m2.5 nylon nuts
module hex_nut_h(min_dia, h, center) {
    ratio = 1/cos(30);
    cylinder(d=min_dia * ratio, $fn=6, h=h, center=center);
}

module hex_nut_v(min_dia, h, h1, center) {
    cube([h, min_dia, h1], center=center);
}

// hole_angles = [30,50,70,90,110,130,150];
// hole_angles = [30,90,150];
hole_angles = [50,70,110,130];
hole_circle_rad = 23.31;
hole_dia1 = 6;
hole_h1 = 3;
hole_h2 = 10;
hole_dia2 = 3.2;

// D = N * (w+1) / PI + 5;
// D = 2*hole_circle_rad + 20;
D=70;
echo(D);
DI = 38;


module holes() {
    for(angle=concat(hole_angles,-1 * hole_angles)) {
        rotate(angle)
        translate([0,hole_circle_rad])
        hole();
    }
}

module hole() {
    cylinder(h=hole_h1+1, d=hole_dia1);
    translate([0,0,hole_h1])
    cylinder(h=hole_h2, d=hole_dia2);
}

translate([0,0,8])
%cylinder(d=2*25.4);

difference() {
    union() {
        cylinder(d=D, h=5, center=true, $fn=360);

        if(0)
        translate([0,0,2.5])
        linear_extrude(height=5)
        difference() {
            circle(d=D, $fn=360);
            circle(d=D-3, $fn=360);
        }
    }

    translate([0,0,-2.6])
    holes();

    cutout();
}

module cutout() { 
rotate(90)
translate([(D+DI)/4,0,0])
cube([D,11,41], center=true);
}
