$fn = 36;
N = 12;
w = 11.5;

nut_min_dia = 5.6; // adafruit m2.5 nylon nuts
module hex_nut_h(min_dia, h, center) {
    ratio = 1/cos(30);
    cylinder(d=min_dia * ratio, $fn=6, h=h, center=center);
}

module hex_nut_v(min_dia, h, h1, center) {
    cube([h, min_dia, h1], center=center);
}

// hole_angles = [30,50,70,90,110,130,150];
// hole_angles = [30,90,150];
hole_angles = [50,70,110,130];
hole_circle_rad = 23.31;
hole_dia1 = 6;
hole_h1 = 3;
hole_h2 = 10;
hole_dia2 = 3.2;

// D = N * (w+1) / PI + 5;
// D = 2*hole_circle_rad + 20;
D=70;
echo(D);
DI = 38;


module holes() {
    for(angle=concat(hole_angles,-1 * hole_angles)) {
        rotate(angle)
        translate([0,hole_circle_rad])
        hole();
    }
}

module hole() {
    cylinder(h=hole_h1+1, d=hole_dia1);
    translate([0,0,hole_h1])
    cylinder(h=hole_h2, d=hole_dia2);
}

translate([0,0,8])
%cylinder(d=2*25.4);

difference() {
    cylinder(d=D, h=5, center=true, $fn=360);

    cylinder(d=DI, h=8, center=true);

    for(i=[0:1:N])
    rotate(i*360/N)
    translate([D/2,0,0])
    {

        if (i % 2 == 0) { even(); } else { odd(); }
    }

    translate([0,0,-2.6])
    holes();
}

module even() {
    translate([-6.2, 0, 0]) {
        cylinder(d=2.5, h=8, center=true);

        translate([0, 0, 1])
        rotate(30)
        hex_nut_h(nut_min_dia, 4, center=true);
        translate([3,0,-6])
        cube([14, w, 8], center=true);
    }
}

module odd() {
    translate([4,0,0])
    {
        cube([10, w, 8], center=true);
        translate([-4,0,0])
        {
            rotate([0,90,0])
            cylinder(d=2.5, h=15, center=true);

            translate([-3,0,0])
            hex_nut_v(nut_min_dia, 2, 8, true);
        }
    }
}


